Foxit PDF SDK

Public Types | Public Member Functions | List of all members
foxit.pdf.objects.PDFNameTree Class Reference
Inheritance diagram for foxit.pdf.objects.PDFNameTree:

## Public Types
enum | Type { Type.e_Dests = 1, Type.e_JavaScript = 2, Type.e_EmbeddedFiles = 3, Type.e_Pages = 4, Type.e_Templates = 5 }
| Enumeration for name tree type. More...

## Public Member Functions
| PDFNameTree (PDFDoc document, PDFNameTree.Type type)
| Constructor, with parameters. More...
| PDFNameTree ()
| Constructor.
| PDFNameTree (PDFNameTree other)
| Constructor, with another PDF name tree object. More...
bool | Add (string name, PDFObject pdf_object)
| Add a new key name with a PDF object as its value. More...
int | GetCount ()
| Get the count of elements in current name tree. More...
string | GetName (int index)
| Get a key name in the name tree, by index. More...
PDFObject | GetObj (string name)
| Get the value (as PDF object) of a specified key name. More...
PDFNameTree.Type | GetType ()
| Get the type of current name tree. More...
bool | HasName (string name)
| Check if the specified key name exists in current name tree. More...
bool | IsEmpty ()
| Check whether current object is empty or not. More...
bool | RemoveAllObjs ()
| Remove all key names from current name tree, along with theirs value (as PDF object). More...
bool | RemoveObj (string name)
| Remove a key name from current name tree, along with its value (as PDF object). More...
bool | Rename (string old_name, string new_name)
| Rename an existing key name to a new key name. More...
bool | SetObj (string name, PDFObject pdf_object)
| Set the value (as PDF object) of a specified key name. More...

## Detailed Description

Name tree is a kind of common data structure in PDF. Name tree serves a similar purpose to PDF dictionary

- associating keys and values - but by different means: in the name tree, a key name is treated as an alias of its value object. That means, the value object can be referred to by the key name instead of by reference object.
  Name tree has following characteristics:

  - key names in a name tree are ordered and each key name in the same name tree is unique;

  - values associated with the key names may be objects of any type, depending on the purpose of the name tree;

  - name tree can represent an arbitrarily large collection of key-value pairs, which can be looked up efficiently without requiring the entire data structure to be read from the PDF file.

  Class PDFNameTree is used to be associated with an existing name tree with specified type or create one. It offers functions to get key-value pairs in the name tree, and set/add/remove any key-value pair. Currently, class PDFNameTree can be associated with following name trees defined in PDF document:

  - Destinations name tree (with type foxit.pdf.objects.PDFNameTree.Type.e_Dests ), which maps name strings to destinations. Values in this name tree should be a destination array (or a reference object to destination array).

  - JavaScript name tree (with type foxit.pdf.objects.PDFNameTree.Type.e_JavaScript ), which maps name strings to document-level JavaScript actions. Values in this name tree should be a javaScript action dictionary (or a reference object to javaScript action dictionary).

  - EmbeddedFiles name tree, with type foxit.pdf.objects.PDFNameTree.Type.e_EmbeddedFiles , which maps name strings to file specifications for embedded file streams. Values in this name tree should be a file specification dictionary (or a reference object to file specification dictionary), which contains an embedded file stream.

  - Pages name tree, with type foxit.pdf.objects.PDFNameTree.Type.e_Pages , which maps name strings to pages. Values in this name tree should be a reference object to a page dictionary.

  - Templates name tree, with type foxit.pdf.objects.PDFNameTree.Type.e_Templates , which maps name strings to hidden pages. Values in this name tree should be a reference object to a hidden page dictionary. Please use function pdf.PDFDoc.HidePageTemplate to hide pages.

  For convenient use about embedded files (known as attachments as well) in a PDF document, please refer to class foxit.pdf.Attachments .

See also
  foxit.pdf.Attachments

## Member Enumeration Documentation

## ◆ Type

enum foxit.pdf.objects.PDFNameTree.Type
| strong

Enumeration for name tree type.

Values of this enumeration should be used alone.

Enumerator
e_Dests | "Dests" name tree.
e_JavaScript | "JavaScript" name tree.
e_EmbeddedFiles | "EmbeddedFiles" name tree.
e_Pages | "Pages" name tree.
e_Templates | "Templates" name tree.

## Constructor & Destructor Documentation

## ◆ PDFNameTree() [1/2]

foxit.pdf.objects.PDFNameTree.PDFNameTree | ( | PDFDoc | document,
|  | PDFNameTree.Type | type
| ) |  |
| inline

Constructor, with parameters.

If there exists name tree with specified type in the PDF document, this function is just to construct a PDF name tree object to be associated with the name tree. If there is no such name tree in PDF document, the constructed PDF name tree object can be used to create such name tree in PDF document and add items to the name tree.

Parameters

  [in] | document | A valid PDF document object.
  [in] | type | The type of the name tree. Please refer to values starting from foxit.pdf.objects.PDFNameTree.Type.e_Dests and this should be one of these values.

## ◆ PDFNameTree() [2/2]

foxit.pdf.objects.PDFNameTree.PDFNameTree | ( | PDFNameTree | other | ) |
| inline

Constructor, with another PDF name tree object.

Parameters

  [in] | other | Another PDF name tree object.

## Member Function Documentation

## ◆ Add()

bool foxit.pdf.objects.PDFNameTree.Add | ( | string | name,
|  | PDFObject | pdf_object
| ) |  |
| inline

Add a new key name with a PDF object as its value.

All PDF objects in the name tree are ordered by their names. When a new PDF object is added, Foxit PDF SDK will find a suitable place in the name tree to add it. After adding successfully, the indexes of some old keys may be changed.

Parameters

  [in] | name | String for a new key name. This should not be an empty string. This new name should not have existed in current name tree.
  [in] | pdf_object | A PDF object, to be set with the new name. The type of this PDF object should match current name tree; otherwise, the input PDF object is invalid. Please refer to comment of class PDFNameTree for more details. User should not release this PDF object after this function succeeds.

Returns
  true means success, while false means failure.

## ◆ GetCount()

int foxit.pdf.objects.PDFNameTree.GetCount | ( |  | ) |
| inline

Get the count of elements in current name tree.

Returns
  The element count.

## ◆ GetName()

string foxit.pdf.objects.PDFNameTree.GetName | ( | int | index | ) |
| inline

Get a key name in the name tree, by index.

Parameters

  [in] | index | Index of the key name to be retrieved. Valid range: from 0 to (count-1). count is returned by function PDFNameTree.GetCount .

Returns
  A string that represents the key name.

## ◆ GetObj()

PDFObject foxit.pdf.objects.PDFNameTree.GetObj | ( | string | name | ) |
| inline

Get the value (as PDF object) of a specified key name.

Parameters

  [in] | name | String for a key name. It should not be an empty string.

Returns
  A PDFObject object. The type of returned PDF object depends on the purpose of current name tree. Please refer to comment of class PDFNameTree for more details. If not found, this function will return null.

## ◆ GetType()

PDFNameTree.Type foxit.pdf.objects.PDFNameTree.GetType | ( |  | ) |
| inline

Get the type of current name tree.

Returns
  Type of current name tree. Please refer to values starting from foxit.pdf.objects.PDFNameTree.Type.e_Dests and this would be one of these values.

## ◆ HasName()

bool foxit.pdf.objects.PDFNameTree.HasName | ( | string | name | ) |
| inline

Check if the specified key name exists in current name tree.

Parameters

  [in] | name | A string that represents the key name to be checked. It should not be an empty string.

Returns
  true means the specified name exists in current name tree, and false means the specified name does not exist in current name tree.

## ◆ IsEmpty()

bool foxit.pdf.objects.PDFNameTree.IsEmpty | ( |  | ) |
| inline

Check whether current object is empty or not.

When the current object is empty, that means current object is useless.

Returns
  true means current object is empty, while false means not.

## ◆ RemoveAllObjs()

bool foxit.pdf.objects.PDFNameTree.RemoveAllObjs | ( |  | ) |
| inline

Remove all key names from current name tree, along with theirs value (as PDF object).

Returns
  true means success, while false means failure.

## ◆ RemoveObj()

bool foxit.pdf.objects.PDFNameTree.RemoveObj | ( | string | name | ) |
| inline

Remove a key name from current name tree, along with its value (as PDF object).

If the input name does not exist in current name tree, this function will return true directly.

Parameters

  [in] | name | String for a key name to be removed. This should not be an empty string.

Returns
  true means success, while false means failure.

## ◆ Rename()

bool foxit.pdf.objects.PDFNameTree.Rename | ( | string | old_name,
|  | string | new_name
| ) |  |
| inline

Rename an existing key name to a new key name.

Parameters

  [in] | old_name | String for an old key name which is to be renamed. This should not be an empty string. This name should have existed in current name tree.
  [in] | new_name | String for a new key name. This should not be an empty string. This new name should not have existed in current name tree.

Returns
  true means success, while false means failure.

## ◆ SetObj()

bool foxit.pdf.objects.PDFNameTree.SetObj | ( | string | name,
|  | PDFObject | pdf_object
| ) |  |
| inline

Set the value (as PDF object) of a specified key name.

Parameters

  [in] | name | String for a key name. It should not be an empty string. This name should have existed in current name tree.
  [in] | pdf_object | A PDF object to be set as the name's value. It should not be null. The type of this PDF object should match current name tree; otherwise, the input PDF object is invalid. Please refer to comment of class PDFNameTree for more details. User should not release this PDF object after this function succeeds.

Returns
  true means success, while false means failure.